use spider::{hashbrown::HashMap, tokio};

#[tokio::main]
async fn main() {

    let args = std::env::args().collect::<Vec<String>>();

    let url = &args[1];
    let budget = &args[2];
    let budget = match budget.parse::<u32>() {
        Ok(x) => x,
        Err(_) => panic!("Second arg must be a int"),
    };


    let mut site = spider::website::Website::new(url)
        .with_budget(Some(HashMap::from([
            ("*", budget),
        ])))
        .with_tld(true)
        .with_on_link_find_callback(Some(|from, to| {
            let from = from.as_ref().to_string();
            let to = to.as_ref().to_string();

            let from = from.trim();
            let to= to.trim();

            println!("{from};->;{to}"); 
        }))
        .build()
        .unwrap();

    site.crawl().await;
}

